/* =========================================================
  2023.12.01   ˰
    "aes128/cbc/pkcs5padding" "aes128/cbc/pkcs7padding"
    "aes192/cbc/pkcs5padding" "aes192/cbc/pkcs7padding"
    "aes256/cbc/pkcs5padding" "aes256/cbc/pkcs7padding"
    "base64"
    "hex" or "HEX" : ҹڿ , ҹڷ   

  2023.12.14 ߰  ˰ 
    "md5"
    "sha1"
    "sha224", "sha256", "sha512", "sha512/224", "sha512/256"
    "sha3/224" Ǵ "sha3_224"
    "sha3/256" Ǵ "sha3_256"
    "sha3/512" Ǵ "sha3_512"
============================================================ */
#ifndef __XCIPHER_H__
#define __XCIPHER_H__

#define XCIPHER_IN_LEN_PROPERTIES 	10240
#define XCIPHER_OUT_LEN_ERR_MSG 	1024

#define XCIPHER_DATA_TYPE_BUFFER    0
#define XCIPHER_DATA_TYPE_FILE      1
#define XCIPHER_DATA_TYPE_FILENAME  2

/*============= aes cbc ȣȭ/ȣȭ ʱȭ Macro Լ   =============*/
// algorithm = "aes128/cbc/pkcs5padding" Ǵ "aes128/cbc/pkcs7padding"
//             "aes192/cbc/pkcs5padding" Ǵ "aes192/cbc/pkcs7padding"
//             "aes256/cbc/pkcs5padding" Ǵ "aes256/cbc/pkcs7padding"
#define XCIPHER_init_aes_cbc(io, algorithm, key, key_len, iv, iv_len) \
        do {\
            XCIPHER_set_algorithm((io), algorithm);\
            XCIPHER_set_key((io), key, key_len);\
            XCIPHER_set_iv((io), iv, iv_len);\
        }while(0)

#define XCIPHER_init_aes128_cbc(io, key, key_len, iv, iv_len)\
            XCIPHER_init_aes_cbc(io, "aes128/cbc/pkcs5padding", key, key_len, iv, iv_len)

#define XCIPHER_init_aes192_cbc(io, key, key_len, iv, iv_len)\
            XCIPHER_init_aes_cbc(io, "aes192/cbc/pkcs5padding", key, key_len, iv, iv_len) 

#define XCIPHER_init_aes256_cbc(io, key, key_len, iv, iv_len)\
            XCIPHER_init_aes_cbc(io, "aes256/cbc/pkcs5padding", key, key_len, iv, iv_len) 
            
/*============= Base64 encoding/decoding ʱȭ Macro Լ   =============*/
#define XCIPHER_init_base64(io)   XCIPHER_set_algorithm((io), "base64") 


/*============= Hexa encoding/decoding ʱȭ Macro Լ   =============*/
// encoding 16 빮ڷ  . decoding /ҹ о
#define XCIPHER_init_HEX(io)  XCIPHER_set_algorithm((io), "HEX") 

// encoding 16 ҹڷ  . decoding /ҹ о
#define XCIPHER_init_hex(io)  XCIPHER_set_algorithm((io), "hex") 

/*============= Message Digest ʱȭ Macro Լ   =============*/
#define XCIPHER_init_md5(io) XCIPHER_set_algorithm((io), "md5") 
// algorithm = "sha1", "sha224", "sha256", "sha512", "sha512/224", "sha512/256"
//             "sha3/224" Ǵ "sha3_224", "sha3/256" Ǵ "sha3_256", "sha3/512" Ǵ "sha3_512"
#define XCIPHER_init_sha(io, algorithm)  XCIPHER_set_algorithm((io), algorithm)
#define XCIPHER_init_sha1(io)            XCIPHER_set_algorithm((io), "sha1")
#define XCIPHER_init_sha224(io)          XCIPHER_set_algorithm((io), "sha224")
#define XCIPHER_init_sha256(io)          XCIPHER_set_algorithm((io), "sha256")
#define XCIPHER_init_sha512(io)          XCIPHER_set_algorithm((io), "sha512")
#define XCIPHER_init_sha512_224(io)      XCIPHER_set_algorithm((io), "sha512/224")
#define XCIPHER_init_sha512_256(io)      XCIPHER_set_algorithm((io), "sha512/256")
#define XCIPHER_init_sha3_224(io)        XCIPHER_set_algorithm((io), "sha3_224")
#define XCIPHER_init_sha3_256(io)        XCIPHER_set_algorithm((io), "sha3_256")
#define XCIPHER_init_sha3_512(io)        XCIPHER_set_algorithm((io), "sha3_512")


//////////////////////////////////////////////////////////////////////////////////////////
struct XCIPHER_in_s
{
    int   size;         // input data size
    const void *data;         //  
    char  properties[XCIPHER_IN_LEN_PROPERTIES]; // ˰  ߰ Ӽ 
};

struct XCIPHER_out_s{
    char err_msg[XCIPHER_OUT_LEN_ERR_MSG]; //  ޽
    int  size;                             // output buffer ũ, Ŀ input Ͱ ȯ   ũ
    void *data;                            // ȯ  Ǵ buffer
};

struct XCIPHER_io_s{
    struct XCIPHER_in_s  in;
    struct XCIPHER_out_s out;
};
typedef struct XCIPHER_io_s XCIPHER_io_t;

const char *XCIPHER_get_algorithm(XCIPHER_io_t *io);
int         XCIPHER_get_input_type(XCIPHER_io_t *io);
const char *XCIPHER_get_iv (XCIPHER_io_t *io);
int         XCIPHER_get_iv_len(XCIPHER_io_t *io);
const char *XCIPHER_get_key(XCIPHER_io_t *io);
int         XCIPHER_get_key_len(XCIPHER_io_t *io);
int         XCIPHER_get_output_type(XCIPHER_io_t *io);
void        XCIPHER_set_algorithm(XCIPHER_io_t *io, const char *algorithm);
int         XCIPHER_set_io(XCIPHER_io_t *io, const char *in_data, int in_data_size, char *out_buf, int out_buf_size);
int         XCIPHER_set_input (XCIPHER_io_t *io, const char *in_data, int in_data_size, int data_type);
void        XCIPHER_set_iv (XCIPHER_io_t *io, const char *iv, int iv_len);
void        XCIPHER_set_key(XCIPHER_io_t *io, const char *key, int key_len);
int         XCIPHER_set_output(XCIPHER_io_t *io, char *out_buf,       int out_buf_size, int data_type);

int XCIPHER_encrypt(XCIPHER_io_t *io);
int XCIPHER_decrypt(XCIPHER_io_t *io);

#endif
